import { PgPort } from "~/server/utils/postgres"
import { SESSION_PASSWORD } from "../../utils"

export default defineEventHandler(async (event) => {
  try {
    const body = await readBody(event)
    const username = body.username
    const session = await useSession(event, { password: SESSION_PASSWORD })
    await session.update({ username })
    // 生产环境要求必须是先创建好服务器，再启动服务
    if (process.env.NODE_ENV === 'development') {
      return false
    } else {
      let result = await getPgTableData('user', username)
      return result
    }
  } catch (err) {
    throw createError({
      statusCode: 500,
      statusMessage: '登录失败'
    })
  }
})