import fs from 'fs'
import path from 'path'

export default defineEventHandler(async (event) => {
    let username = event.context.username
    let docker = createDockerFactory(username)
    let postgres = await docker.checkContainer('postgres_12')
    if (!postgres) {
      postgres = await docker.checkAndCreateContainer({ name: 'postgres_12', img: 'postgres:12', env: ["POSTGRES_PASSWORD=postgres"], portBindings: { '5432/tcp': [{ HostPort: PgPort.toString() }] } })
      await docker.startContainer({ container: postgres })
      await sleep(3000)
    } else {
      await docker.startContainer({ container: postgres })
      await sleep(3000)
    }
    let client = await createPgClientFactory()
    let result = await executePgQuery({ client, query: "SELECT u.datname  FROM pg_catalog.pg_database u where u.datname='backend_helper';" })
    if (result.rows.length === 0) {
      await executePgQuery({ client, query: 'CREATE DATABASE backend_helper'})
      await client.end()
      client = await createPgClientFactory('backend_helper')
      const sqlCreateUser = fs
      await executePgQuery({ client, query: fs.readFileSync(path.resolve('./public/files/postgres/create_user.sql'), { encoding: 'utf-8' })})
      await executePgQuery({ client, query: fs.readFileSync(path.resolve('./public/files/postgres/create_v2.sql'), { encoding: 'utf-8' })})
      await executePgQuery({ client, query: fs.readFileSync(path.resolve('./public/files/postgres/create_v1.sql'), { encoding: 'utf-8'})})
    } else {
      client = await createPgClientFactory('backend_helper')
    }
    let user = await getPgTableData('user', username)
    if (result.rowCount === 0) {
      const port = await getAvailableNodePort(HOST)
      await executePgQuery({ client, query: `INSERT INTO public."user"(username, port) VALUES ('${username}', '${port}');`})
      user = await getPgTableData('user', username)
    }

    return user
})